#include <IRremote.h>

//Motor A
const int motorA1 = 2;
const int motorA2 = 4;

//Motor B
const int motorB1 = 11;
const int motorB2 = 10;

//IR sensor
#define irPin 12

// Change to the HEX values of your remote control
#define FWRD 0xFF18E7UL  //Forward
#define BKWD 0xFF4AB5UL  //Backward
#define LEFT 0xFF10EFUL  //Turn Left
#define RGHT 0xFF5AA5UL  //Turn Right
#define STOP 0xFF38C7UL  //Stop Motors

IRrecv irrecv(irPin);
decode_results results;

void setup() {
  Serial.begin(9600);
  pinMode(motorA1, OUTPUT);
  pinMode(motorA2, OUTPUT);
  pinMode(motorB1, OUTPUT);
  pinMode(motorB2, OUTPUT);

  irrecv.enableIRIn();
}

void loop() {
  static unsigned long lastCommand = 0;
  if (irrecv.decode(&results)) {
    if (results.value != lastCommand) {
      if (results.value != 0xFFFFFFFF) { 
        lastCommand = results.value;
        switch (results.value) {
          case FWRD:
            motorsFWRD();
            break;
          case BKWD:
            motorsBKWD();
            break;
          case RGHT:
            motorsRGHT();
            break;
          case LEFT:
            motorsLEFT();
            break;
          case STOP:
            motorsSTOP();
            break;
          default:
            Serial.println("Unknown command!");
            break;
        }
      }
    }
    irrecv.resume();
    delay(100);
  }

  if (!irrecv.isIdle()) {
    delay(50);
  }
}

void motorsFWRD() {
  digitalWrite(motorA1, HIGH);
  digitalWrite(motorA2, LOW);
  digitalWrite(motorB1, HIGH);
  digitalWrite(motorB2, LOW);
}

void motorsBKWD() {
  digitalWrite(motorA1, LOW);
  digitalWrite(motorA2, HIGH);
  digitalWrite(motorB1, LOW);
  digitalWrite(motorB2, HIGH);
}

void motorsLEFT() {
  digitalWrite(motorA1, LOW);
  digitalWrite(motorA2, HIGH);
  digitalWrite(motorB1, HIGH);
  digitalWrite(motorB2, LOW);
}

void motorsRGHT() {
  digitalWrite(motorA1, HIGH);
  digitalWrite(motorA2, LOW);
  digitalWrite(motorB1, LOW);
  digitalWrite(motorB2, HIGH);
}

void motorsSTOP() {
  digitalWrite(motorA1, LOW);
  digitalWrite(motorA2, LOW);
  digitalWrite(motorB1, LOW);
  digitalWrite(motorB2, LOW);
}